﻿// <copyright file="IResolver.cs" company="Selectron Systems AG">
// Copyright (c) Selectron Systems AG. All rights reserved.
// </copyright>

namespace ObjectDiffer.Presentation.Evaluation
{
    using Ninject;

    /// <summary>
    /// Defines the interface of the object resolver
    /// </summary>
    public interface IResolver
    {
        /// <summary>
        /// Gets the kernel.
        /// </summary>
        /// <value>
        /// The kernel.
        /// </value>
        IKernel Kernel { get; }

        /// <summary>
        /// Gets the instance from the resolver.
        /// </summary>
        /// <typeparam name="T">Type of requested instance.</typeparam>
        /// <returns>
        /// The <see cref="T" />.
        /// </returns>
        T Resolve<T>();
    }
}
