﻿// <copyright file="Resolver.cs" company="Selectron Systems AG">
// Copyright (c) Selectron Systems AG. All rights reserved.
// </copyright>

namespace ObjectDiffer.Presentation.Evaluation
{
    using Ninject;

    /// <summary>
    /// Defines the object resolver
    /// </summary>
    public class Resolver : IResolver
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="Resolver" /> class.
        /// </summary>
        /// <param name="kernel">The kernel.</param>
        public Resolver(IKernel kernel)
        {
            this.Kernel = kernel;
            this.Kernel.Load<NinjectUiModule>();
            this.Kernel.Bind<IResolver>().ToConstant(this);
        }

        /// <summary>
        /// Gets the kernel.
        /// </summary>
        public IKernel Kernel { get; private set; }

        /// <summary>
        /// Gets the instance from the resolver.
        /// </summary>
        /// <typeparam name="T">Type of requested instance.</typeparam>
        /// <returns>
        /// The <see cref="T" />.
        /// </returns>
        public T Resolve<T>()
        {
            return this.Kernel.Get<T>();
        }
    }
}
